/**
 * Copyright (C) 2010 [[XYZ]], Helmholtz Centre for Environmental Research GmbH - UFZ <abmland@ufz.de>
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package abmland.common;

import java.util.Calendar;
import java.util.GregorianCalendar;

import repast.simphony.parameter.StringConverter;

/**
 * Very stupid approach to have better format for Simulation years. XXX Probably it
 * could be an improvement to share and not only use a Calendar object
 * here so the user may select certain starting days even for a simulation.
 *
 * @author dkahlenb
 */
public class DateConverterStub implements StringConverter<Integer> {

	/** {@inheritDoc} */
	public Integer fromString(String strRep) {
		// TODO May be it's more nice if we return a Calendar object here...
		return Integer.valueOf(Integer.parseInt(strRep));
	}

	/** {@inheritDoc} */
	public String toString(Integer year) {
		Calendar c = new GregorianCalendar(year.intValue(), Calendar.JANUARY, 1);
		return String.format("%1$tY", c);
	}
}
