/**
 * Copyright (C) 2010 [[XYZ]], Helmholtz Centre for Environmental Research GmbH - UFZ <abmland@ufz.de>
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package abmland.common;

public class DummyDataListenerModel implements DataListener {

	/** {@inheritedDoc} */
	public void dataChanged(DataEvent evt) {
		DataEventMgr.notifyListeners(evt);
	}

	/**
	 * {{{ XXX Maybe we could fix that completely by introducing one more
	 * inherited class combing the DefaultContext with the DataEventMgr the
	 * combination being extended by this class, compare to AbstractAllCells
	 */
	public synchronized void addDataChangeListener(DataListener d) {
		DataEventMgr.addDataChangeListener(this, d);
	}

	public synchronized void removeDataChangeListener(DataListener d) {
		DataEventMgr.removeDataChangeListener(d);
	}
	/**
	 * }}}
	 */
}
