/**
 * Copyright (C) 2010 [[XYZ]], Helmholtz Centre for Environmental Research GmbH - UFZ <abmland@ufz.de>
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package abmland.common;

import java.util.Hashtable;
import java.util.Map;

import org.apache.log4j.Logger;

/**
 * Property values for the resident model/agents are stored here. Names and
 * paths for initial data
 */
public final class Properties extends java.util.Properties {

	private final static Logger log = Logger.getLogger(Properties.class);
	private static Properties p = null;
	static {
		try {
			p = new Properties();
			p.load(Properties.class.getClassLoader().getResourceAsStream(
					"names.properties"));
		} catch (Throwable t) {
			log.error(t);
		}
	}

	public final static String RESIDENT_MODEL_CLASS_NAME = p.getProperty("RESIDENT_MODEL_CLASS_NAME");
	public final static String ASSAYAREA = p.getProperty("ASSAYAREA");
	public final static String CASESTUDY = p.getProperty("CASESTUDY");
	public final static String DECISIONMODE = p.getProperty("DECISIONMODE");
	public final static String SCENARIONAME = p.getProperty("SCENARIONAME");
	public final static String STARTYEAR = p.getProperty("STARTYEAR");
	public final static String SCHEDULECONTROLLER = p
	.getProperty("SCHEDULECONTROLLER");
	public final static String INITIALTOTALNUMBEROFPOPULATION = p
			.getProperty("INITIALTOTALNUMBEROFPOPULATION");
	public final static String RESIDENT_AGENT_SHAPEFILE = p
			.getProperty("RESIDENT_AGENT_SHAPEFILE");
	public final static String RESIDENT_GEOGRAPHY = p
			.getProperty("RESIDENT_GEOGRAPHY");
	public final static String RESIDENT_AGENT_CONTEXT = p
			.getProperty("RESIDENT_AGENT_CONTEXT");
	public final static String RESIDENT_MODEL_CONTEXT = p
			.getProperty("RESIDENT_MODEL_CONTEXT");
	public final static String RESIDENT_MODEL = p.getProperty("RESIDENT_MODEL");
	public final static String RESIDENT_AGENT = p.getProperty("RESIDENT_AGENT");
	public final static String INFRASTRUCTURE_AGENT_SHAPEFILE = p
			.getProperty("INFRASTRUCTURE_AGENT_SHAPEFILE");
	public final static String INFRASTRUCTURE_GEOGRAPHY = p
			.getProperty("INFRASTRUCTURE_GEOGRAPHY");
	public final static String INFRASTRUCTURE_AGENT_CONTEXT = p
			.getProperty("INFRASTRUCTURE_AGENT_CONTEXT");
	public final static String INFRASTRUCTURE_MODEL_CONTEXT = p
			.getProperty("INFRASTRUCTURE_MODEL_CONTEXT");
	public final static String INFRASTRUCTURE_MODEL = p
			.getProperty("INFRASTRUCTURE_MODEL");
	public final static String INFRASTRUCTURE_AGENT = p
			.getProperty("INFRASTRUCTURE_AGENT");
	public final static String LOBBYIST_AGENT_SHAPEFILE = p
			.getProperty("LOBBYIST_AGENT_SHAPEFILE");
	public final static String LOBBYIST_GEOGRAPHY = p
			.getProperty("LOBBYIST_GEOGRAPHY");
	public final static String LOBBYIST_AGENT_CONTEXT = p
			.getProperty("LOBBYIST_AGENT_CONTEXT");
	public final static String LOBBYIST_MODEL_CONTEXT = p
			.getProperty("LOBBYIST_MODEL_CONTEXT");
	public final static String LOBBYIST_MODEL = p.getProperty("LOBBYIST_MODEL");
	public final static String LOBBYIST_AGENT = p.getProperty("LOBBYIST_AGENT");
	public final static String PLANNER_AGENT_SHAPEFILE = p
			.getProperty("PLANNER_AGENT_SHAPEFILE");
	public final static String PLANNER_GEOGRAPHY = p
			.getProperty("PLANNER_GEOGRAPHY");
	public final static String PLANNER_AGENT_CONTEXT = p
			.getProperty("PLANNER_AGENT_CONTEXT");
	public final static String PLANNER_MODEL_CONTEXT = p
			.getProperty("PLANNER_MODEL_CONTEXT");
	public final static String PLANNER_MODEL = p.getProperty("PLANNER_MODEL");
	public final static String PLANNER_AGENT = p.getProperty("PLANNER_AGENT");
	public final static String BUSINESS_AGENT_SHAPEFILE = p
			.getProperty("BUSINESS_AGENT_SHAPEFILE");
	public final static String BUSINESS_GEOGRAPHY = p
			.getProperty("BUSINESS_GEOGRAPHY");
	public final static String BUSINESS_AGENT_CONTEXT = p
			.getProperty("BUSINESS_AGENT_CONTEXT");
	public final static String BUSINESS_MODEL_CONTEXT = p
			.getProperty("BUSINESS_MODEL_CONTEXT");
	public final static String BUSINESS_MODEL = p.getProperty("BUSINESS_MODEL");
	public final static String BUSINESS_AGENT = p.getProperty("BUSINESS_AGENT");
	public final static String DEVELOPER_AGENT_SHAPEFILE = p
			.getProperty("DEVELOPER_AGENT_SHAPEFILE");
	public final static String DEVELOPER_GEOGRAPHY = p
			.getProperty("DEVELOPER_GEOGRAPHY");
	public final static String DEVELOPER_AGENT_CONTEXT = p
			.getProperty("DEVELOPER_AGENT_CONTEXT");
	public final static String DEVELOPER_MODEL_CONTEXT = p
			.getProperty("DEVELOPER_MODEL_CONTEXT");
	public final static String DEVELOPER_MODEL = p
			.getProperty("DEVELOPER_MODEL");
	public final static String DEVELOPER_AGENT = p
			.getProperty("DEVELOPER_AGENT");
	// TODO add those convenience strings for all other agents
	public final static String COMMERCIALSPACEDEMAND = p
			.getProperty("COMMERCIALSPACEDEMAND");
	public final static String COMMERCIALSPACEOCCUPIED = p
			.getProperty("COMMERCIALSPACEOCCUPIED");
	public final static String INFRASTRUCTUREDEMAND = p
			.getProperty("INFRASTRUCTUREDEMAND");
	public static Map<Object, Boolean> modelsFinishedStatii = new Hashtable<Object, Boolean>();
}