/**
 * Copyright (C) 2010 [[XYZ]], Helmholtz Centre for Environmental Research GmbH - UFZ <abmland@ufz.de>
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package abmland.core.sandbox;


public class Bounds {

	public static <T extends Comparable> boolean isOuterBounds(T value,
			T lowerBound, T upperBound) {
		if ((value.compareTo(lowerBound) < 0)
				|| (value.compareTo(upperBound) > 0))
			return true;
		return false;
	}

	public static <T extends Comparable> boolean areOuterBounds(T one,
			T another, T lowerBound, T upperBound) {
		if (isOuterBounds(one, lowerBound, upperBound)
				|| isOuterBounds(another, lowerBound, upperBound))
			return true;
		return false;
	}
}
