package tcadaption.sandbox;

import tcadaption.BoundsUtil;
import fj.P1;
import fj.data.Either;

/**
 * This is the default implementation of the interface describing transfer
 * volume potential regarding units of floating point values.
 * 
 * @author dkahlenb
 * 
 */
public class TransferVolumeFloatsDefaultImpl implements TransferVolumeFloats {

	static float MIN = 0.0f;
	static float MAX = 10000f;
	public static float value = MIN;

	public Float getVolume() {

		return TransferVolumeFloatsDefaultImpl.value;
	}
	
	private static P1<Either<Exception, Float>> eSetVolume(final Float volume) {
		return new P1<Either<Exception, Float>>() {
			@Override
			public Either<Exception, Float> _1() {
				try {
					if (BoundsUtil.isOuterBounds(volume, MIN, MAX)) {
						throw new Exception(volume + " outer bounds");
					}
					TransferVolumeFloatsDefaultImpl.value = volume;
					return Either.right(TransferVolumeFloatsDefaultImpl.value);
				} catch (Exception e) {
					return Either.left(e);
				}
			}

		};
	}
	
	public boolean setVolume(Float volume) {
		float EDOM = -9999999f;
		P1<Either<Exception, Float>> lazyE = TransferVolumeFloatsDefaultImpl.eSetVolume(volume);
		TransferVolumeFloatsDefaultImpl.value = (lazyE._1().isLeft() ? EDOM : lazyE._1().right().value());
		if(lazyE._1().isLeft()) {
			System.err.println("Failed with " + lazyE._1().left().value());
			return false;
		}
		return true;
	}
}
