/**
 * Copyright (C) 2010 [[XYZ]], Helmholtz Centre for Environmental Research GmbH - UFZ <abmland@ufz.de>
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package abmland.core.sandbox;

import fj.P1;
import fj.data.Either;

public class TransferVolumeIntsDefaultImpl implements TransferVolumeInts {

	static int MIN = 0;
	static int MAX = 10000;
	static int value = MIN ;

	public Integer getVolume() {
		
		return TransferVolumeIntsDefaultImpl.value ;
	}

	private static P1<Either<Exception, Integer>> eSetVolume(final Integer volume) {
		return new P1<Either<Exception, Integer>>() {
			@Override
			public Either<Exception, Integer> _1() {
				try {
					if (BoundsUtil.isOuterBounds(volume, MIN, MAX)) {
						throw new Exception(volume + " outer bounds");
					}
					TransferVolumeIntsDefaultImpl.value = volume;
					return Either.right(TransferVolumeIntsDefaultImpl.value);
				} catch (Exception e) {
					return Either.left(e);
				}
			}

		};
	}
	
	public boolean setVolume(Integer volume) {
		int EDOM = -1;
		P1<Either<Exception, Integer>> lazyE = TransferVolumeIntsDefaultImpl.eSetVolume(volume);
		TransferVolumeIntsDefaultImpl.value = (lazyE._1().isLeft() ? EDOM : lazyE._1().right().value());
		if(lazyE._1().isLeft()) {
			System.err.println("Failed with " + lazyE._1().left().value());
			return false;
		}
		return true;
	}
}
