/**
 * Copyright (C) 2010 [[XYZ]], Helmholtz Centre for Environmental Research GmbH - UFZ <abmland@ufz.de>
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package abmland.data;

import static abmland.common.LogExceptionHandler.handleException;
import static org.apache.log4j.Logger.getLogger;

import java.util.Random;

import org.apache.log4j.Logger;

/**
 * TODO Integrate dave's suggestion for the description value, each enum
 * instance.
 *
 * @author dkahlenb
 *
 */
public enum CLCover {

	/** ECLC 1901 */
	TOWN_CENTRE(1901, "Add a description"),
	/** ECLC 1902 */
	NINETEENTH_CENTURY_TENEMENT(1902, "Add a description"),
	/** ECLC 1903 */
	PREFAB_MULTI_STOREY(1903, "Add a description"),
	/** ECLC 1904 */
	MULTI_STOREY_HOUSING(1904, "Add a description"),
	/** ECLC 1905 */
	SINGLE_HOUSE__VILLA(1905, "Add a description"),
	/** ECLC 1906 */
	PARK(1906, "Add a description"),
	/** ECLC 1907 */
	URBAN_FOREST(1907, "Add a description"),
	/** ECLC 1908 */
	SPORTS_FIELD(1908, "Add a description"),
	/** ECLC 1909 */
	ALLOTMENT(1909, "Add a description"),
	/** ECLC 1910 */
	HOSPITAL(1910, "Add a description"),
	/** ECLC 1911 */
	SCHOOL(1911, "Add a description"),
	/** ECLC 1912 */
	OTHER_MUNICIPAL_BUILDINGS(1912, "Add a description"),
	/** ECLC 1913 */
	// CAR_PARK,
	/** CLC 111 */
	CONTINUOUS_URBAN_FABRIC(111, "Add a description"),
	/** CLC 112 */
	DISCONTINUOUS_URBAN_FABRIC(112, "Add a description"),
	/** CLC 121 */
	INDUSTRIAL_OR_COMMERCIAL_UNITS(121, "Add a description"),
	/** CLC 122 */
	ROAD_AND_RAIL_NETWORKS_AND_ASSOCIATED_LAND(122, "Add a description"),
	/** CLC 123 */
	PORT_AREAS(123, "Add a description"),
	/** CLC 124 */
	AIRPORTS(124, "Add a description"),
	/** CLC 131 */
	MINERAL_EXTRACTION_SITES(131, "Add a description"),
	/** CLC 132 */
	DUMP_SITES(132, "Add a description"),
	/** CLC 133 */
	CONSTRUCTION_SITES(133, "Add a description"),
	/** CLC 141 */
	GREEN_URBAN_AREAS(141, "Add a description"),
	/** CLC 142 */
	SPORT_AND_LEISURE_FACILITIES(142, "Add a description"),
	/** CLC 211 */
	NONIRRIGATED_ARABLE_LAND(211, "Add a description"),
	/** CLC 212 */
	PERMANENTLY_IRRIGATED_LAND(212, "Add a description"),
	/** CLC 213 */
	RICE_FIELDS(213, "Add a description"),
	/** CLC 221 */
	VINEYARDS(221, "Add a description"),
	/** CLC 222 */
	FRUIT_TREES_AND_BERRY_PLANTATIONS(222, "Add a description"),
	/** CLC 223 */
	OLIVE_GROVES(223, "Add a description"),
	/** CLC 231 */
	PASTURES(231, "Add a description"),
	/** CLC 241 */
	ANNUAL_CROPS_ASSOCIATED_WITH_PERMANENT_CROPS(241, "Add a description"),
	/** CLC 242 */
	COMPLEX_CULTIVATION_PATTERNS(242, "Add a description"),
	/** CLC 243 */
	LAND_PRINCIPALLY_OCCUPIED_BY_AGRICULTURE(243, "Add a description"),
	/** CLC 244 */
	AGROFORESTRY_AREAS(244, "Add a description"),
	/** CLC 311 */
	BROADLEAVED_FOREST(311, "Add a description"),
	/** CLC 312 */
	CONIFEROUS_FOREST(312, "Add a description"),
	/** CLC 313 */
	MIXED_FOREST(313, "Add a description"),
	/** CLC 321 */
	NATURAL_GRASSLANDS(321, "Add a description"),
	/** CLC 322 */
	MOORS_AND_HEATHLAND(322, "Add a description"),
	/** CLC 323 */
	SCLEROPHYLLOUS_VEGETATION(323, "Add a description"),
	/** CLC 324 */
	TRANSITIONAL_WOODLANDSHRUB(324, "Add a description"),
	/** CLC 331 */
	BEACHES_DUNES_SANDS(331, "Add a description"),
	/** CLC 332 */
	BARE_ROCKS(332, "Add a description"),
	/** CLC 333 */
	SPARSELY_VEGETATED_AREAS(333, "Add a description"),
	/** CLC 334 */
	BURNT_AREAS(334, "Add a description"),
	/** CLC 335 */
	GLACIERS_AND_PERPETUAL_SNOW(335, "Add a description"),
	/** CLC 411 */
	INLAND_MARSHES(411, "Add a description"),
	/** CLC 412 */
	PEAT_BOGS(412, "Add a description"),
	/** CLC 421 */
	SALT_MARSHES(421, "Add a description"),
	/** CLC 422 */
	SALINES(422, "Add a description"),
	/** CLC 423 */
	INTERTIDAL_FLATS(423, "Add a description"),
	/** CLC 511 */
	WATER_COURSES(511, "Add a description"),
	/** CLC 512 */
	WATER_BODIES(512, "Add a description"),
	/** CLC 521 */
	COASTAL_LAGOONS(521, "Add a description"),
	/** CLC 522 */
	ESTUARIES(522, "Add a description"),
	/** CLC 523 */
	SEA_AND_OCEAN(523, "Add a description"),
	/** -9999 */
	NO_DATA(Double.NaN, "No data for patch");

	private static final Logger log = getLogger(CLCover.class);

	private double value; // as double

	private String description;

	private CLCover(double value) {
		this.value = value;
		this.description = "No description yet.";
	}

	private CLCover(double value, String description) {
		this.value = value;
		this.description = description;
	}

	private CLCover() {
		this.value = Double.NaN;
	}

	public final double value() {
		return value;
	}

	public final static CLCover valueOf(double value) {
		for (CLCover c : CLCover.values()) {
			if (c.value == value)
				return c;
		}
		if (Double.isNaN(value)) {
			return CLCover.NO_DATA;
		}
		try {
			throw new IllegalArgumentException(
					"No constant (LU value) defined for code "
							+ Double.valueOf(value));
		} catch (Throwable e) {
			handleException(CLCover.class, e);
		}
		return null;
	}

	// public final static double ofValue(double value) {
	//
	// return CLCover.valueOf(value).value();
	// }

	private static Random random = new Random();

	public final static CLCover randomValue() {
		CLCover[] values = CLCover.values();
		return values[random.nextInt(values.length)];
	}

	public static void main(String[] args) {
		// if (args.length != 1) {
		// System.err.println("Usage:  java CLCover <clc>");
		// System.exit(-1);
		// }

		log.info(CLCover.NO_DATA.value());

		log.info(CLCover.valueOf(Double.NaN));

		for (CLCover clc : values())
			log.info("CLC for " + clc + " is " + clc.value());
	}

}
