/**
 * Copyright (C) 2010 [[XYZ]], Helmholtz Centre for Environmental Research GmbH - UFZ <abmland@ufz.de>
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package abmland.data;

import static abmland.common.LogExceptionHandler.handleException;

public enum Issuetypes {
	CRIME_OVER_MEAN(0), CRIME_UNDER_MEAN(1), SCHOOL_WITHIN_250(2), SCHOOL_WITHIN_500(
			3), SCHOOL_MORETHAN_500(4), PUB_TRANSPORT_WITHIN_250(5), PUB_TRANSPORT_WITHIN_500(
			6), PUB_TRANSPORT_MORETHAN_500(7), MAIN_ROADS_WITHIN_250(8), MAIN_ROADS_WITHIN_500(
			9), MAIN_ROADS_MORETHAN_500(10), SHOPPING_WITHIN_250(11), SHOPPING_WITHIN_500(
			12), SHOPPING_MORETHAN_500(13)
	// ,UNSPECIFIED (Double.NaN)
	;

	private double value;

	public final double value() {
		return value;
	}

	public final static Issuetypes valueOf(double value) {
		final int intvalue = (int) value;
		for (Issuetypes c : Issuetypes.values()) {
			if ((int) c.value == intvalue)
				return c;
		}
		// if (Double.isNaN(value)) {
		// return Issuetypes.UNSPECIFIED;
		// }
		try {
			throw new IllegalArgumentException(
					"No constant (issue type) defined for code "
							+ Double.valueOf(value));
		} catch (Throwable e) {
			handleException(CLCover.class, e);
		}
		return null;
	}

	private Issuetypes() {
		this.value = Double.NaN;
	}

	private Issuetypes(double value) {
		this.value = value;
	}

	public static void main(String[] args) {
		System.err.println(Issuetypes.valueOf(0));
		System.err.println(Issuetypes.valueOf(-100));
	}
}
