/**
 * Copyright (C) 2010 [[XYZ]], Helmholtz Centre for Environmental Research GmbH - UFZ <abmland@ufz.de>
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package abmland.data;

/**
 * analogous to second row (17 cohorts) from
 * resmob/data/residential/perCohort/cohorts.csv
 *
 * cohorts age bands ranging in 0-5, 5-10, 10-15... not 0-5, 6-10, 11-15
 *
 * @author dkahlenb
 *
 */
public enum Populationclazzes {

	COHORT00(String.format(_.msg, 0f, 5f)), //
	COHORT01(String.format(_.msg, 5f, 10f)), //
	COHORT02(String.format(_.msg, 10f, 15f)), //
	COHORT03(String.format(_.msg, 15f, 20f)), //
	COHORT04(String.format(_.msg, 20f, 25f)), //
	COHORT05(String.format(_.msg, 25f, 30f)), //
	COHORT06(String.format(_.msg, 30f, 35f)), //
	COHORT07(String.format(_.msg, 35f, 40f)), //
	COHORT08(String.format(_.msg, 40f, 45f)), //
	COHORT09(String.format(_.msg, 45f, 50f)), //
	COHORT10(String.format(_.msg, 50f, 55f)), //
	COHORT11(String.format(_.msg, 55f, 60f)), //
	COHORT12(String.format(_.msg, 60f, 65f)), //
	COHORT13(String.format(_.msg, 65f, 70f)), //
	COHORT14(String.format(_.msg, 70f, 75f)), //
	COHORT15(String.format(_.msg, 75f, 80f)), //
	COHORT16(String.format(_.msg, 80f, 999f)), //
	;

	private Populationclazzes(String value) {
		this.description = value;
	}

	private String description;

	public final String value() {
		return description;
	}
}

final class _ {
	static String msg = "range: %2.0f - %2.0f";
}
