/**
 * Copyright (C) 2010 [[XYZ]], Helmholtz Centre for Environmental Research GmbH - UFZ <abmland@ufz.de>
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package abmland.data;

//import static abmland.data.Properties.UNDEFINED;
import repast.simphony.engine.schedule.ScheduleParameters;

public enum Priorities {

	pINIT(ScheduleParameters.FIRST_PRIORITY)//
	, pINIT_GLOBALS_GETDATA(Double.MAX_VALUE - 1)//
	, pGLOBALS_GETDATA(ScheduleParameters.FIRST_PRIORITY)//
	, pTICK_LOGGER(ScheduleParameters.FIRST_PRIORITY)//
	, pGLOBALS_COMPUTE(1000)//
	, pLOCALS_GETDATA(999)//
	, pLOCALS_COMPUTE(998)//
	, pRESULTS(ScheduleParameters.LAST_PRIORITY);

	// WRONG_CODE and UNDEFINED are a could be not a to be used, as neither
	// Priorities
	// constant is created, given no or any not-enumerated-wrapped double value
	// parameter; it simply results in the constant substituted by zero/null,
	// which isn't as nice, so we let this lines as a hint. The WRONG_CODE may
	// not appear in the values so we made it private accessible only.
	/** private static Priorities WRONG_CODE; */

	private double value; // as double

	private Priorities(double value) {
		// later on we could catch 'wrong' values here, assigning UNDEFINED
		this.value = value;
	}

//	private Priorities() {
//		this.value = UNDEFINED;
//	}

	public final double value() {
		return /** this == Priorities.WRONG_CODE ? UNDEFINED : */
		value;
	}

	public final static Priorities valueOf(double value) {
		final int intvalue = (int) value;
		/**
		 * First matching value is taken
		 */
		for (Priorities c : Priorities.values()) {
			if ((int) c.value == intvalue)
				return c;
		}
		throw new IllegalArgumentException("No constant defined for code " + value);
		// return WRONG_CODE;
	}
}
