/**
 * Copyright (C) 2010 [[XYZ]], Helmholtz Centre for Environmental Research GmbH - UFZ <abmland@ufz.de>
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package abmland.mainctrl.config;

import java.util.ArrayList;
import java.util.List;
import java.util.ListIterator;

import org.simpleframework.xml.Attribute;
import org.simpleframework.xml.core.Commit;

public class AreaParameters {

	@Attribute
	public String ncols, nrows;

	// later on...
	// @Attribute(required = false)
	// public String xllcorner, yllcorner, cellsize, NODATA_value;

	private List<Integer> list;

	public int[] getDims() {
		ListIterator<Integer> it = list.listIterator();
		int[] _ = new int[list.size()];
		while (it.hasNext()) {
			_[it.nextIndex()] = it.next();
		}
		return _;
	}

	/**
	 * The value for the dims array/list are read in from the String here...
	 */
	@Commit
	public void onCommit() {
		// ordering stable?
		this.list = new ArrayList<Integer>();
		// order is important
		this.list.add(new Double(this.nrows).intValue());
		this.list.add(new Double(this.ncols).intValue());
	}
}
