/**
 * Copyright (C) 2010 [[XYZ]], Helmholtz Centre for Environmental Research GmbH - UFZ <abmland@ufz.de>
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package abmland.models;

import java.util.Map;

import repast.simphony.space.grid.GridPoint;
import abmland.data.Householdtypes;
import abmland.data.Issuetypes;
import abmland.types.IHouseholdNumber;
import abmland.types.ISatisfaction;

public interface IResidentModel {

	// /**
	// * TODO AS: To which type is this method associated really? <br>
	// *
	// * Exports a map of CLC per cell to the TODO land use storage (??)
	// *
	// * @return a map of CLC per cell.
	// */
	// ICLCoverSomeCells getLandUseChanges();

	/**
	 * @return a spatial distribution of satisfaction per issue (each issue type), mapped to the
	 *         different hdtypes for each enclosed cell
	 */
	Map<GridPoint, Map<Householdtypes, Map<Issuetypes, ISatisfaction>>> getSatisfaction();

	/**
	 * @return a spatial distribution of household number per hdtype for each
	 *         enclosed cell
	 */
	Map<GridPoint, Map<Householdtypes, IHouseholdNumber>> getTotalHouseholdNumber(); // 0
	// 100000
}
