/**
 * Copyright (C) 2010 [[XYZ]], Helmholtz Centre for Environmental Research GmbH - UFZ <abmland@ufz.de>
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package abmland.models.abstract_impl;

import java.util.Map;
import java.util.Set;

import repast.simphony.space.grid.GridPoint;
import abmland.data.Businesstypes;
import abmland.data.CLCover;
import abmland.data.Issuetypes;
import abmland.models.IBusinessModel;
import abmland.types.IBooleanAllCells;
import abmland.types.IBusinesstypesAllCells;
import abmland.types.IFloorSpaceAllCells;
import abmland.types.ISatisfaction;

public abstract class AbstractBusinessModel implements IBusinessModel {

	/** {@inheritDoc} */ public abstract IBusinesstypesAllCells getBusinessPresence();

	/** {@inheritDoc} */ public abstract IBooleanAllCells getInfrastructureDemand();

	/** {@inheritDoc} */ public abstract Map<GridPoint, CLCover> getLandUseChanges();

	/** {@inheritDoc} */ public abstract IFloorSpaceAllCells getCommercialSpaceDemand();

	/** {@inheritDoc} */ public abstract Map<GridPoint, Map<Businesstypes, Map<Issuetypes, ISatisfaction>>> getSatisfaction();

	/** {@inheritDoc} */ public abstract IFloorSpaceAllCells getCommercialSpaceOccupation();

	/** {@inheritDoc} */ public abstract Set<Map<GridPoint, CLCover>> getProposalsNeedingPermission();
}
