/**
 * Copyright (C) 2010 [[XYZ]], Helmholtz Centre for Environmental Research GmbH - UFZ <abmland@ufz.de>
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package abmland.models.abstract_impl;

import java.util.Map;

import repast.simphony.space.grid.GridPoint;
import abmland.data.CLCover;
import abmland.models.ILobbyistModel;
import abmland.types.IPressure;
import abmland.types.IPressureForCLCoverAllCells;
import abmland.types.IPressureForXTable;

public abstract class AbstractLobbyistModel implements ILobbyistModel {

	/** {@inheritDoc} */ public abstract IPressureForXTable<CLCover> getGlobalPressure();

	/** {@inheritDoc} */ public abstract IPressureForCLCoverAllCells getSpatialPressure();

	/** {@inheritDoc} */ public abstract Map<Map<GridPoint, CLCover>, IPressure> getSupportForPlan();
}
