/**
 * Copyright (C) 2010 [[XYZ]], Helmholtz Centre for Environmental Research GmbH - UFZ <abmland@ufz.de>
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package abmland.models.bindings;

import static org.apache.log4j.Logger.getLogger;

import org.apache.log4j.Logger;

import repast.simphony.context.Context;
import repast.simphony.dataLoader.ContextBuilder;

public class DummyEmptyBundleContexts implements ContextBuilder<Object> {

	private final Logger log = getLogger(getClass().getName());

	private static Context<Object> mainContext;

	public Context<Object> build(Context<Object> context) {
		DummyEmptyBundleContexts.mainContext = context;
		DummyEmptyBundleContexts.mainContext = fillMainContext();
		return DummyEmptyBundleContexts.mainContext;
	}

	private synchronized Context<Object> fillMainContext() {
		Context<Object> fullcontext = DummyEmptyBundleContexts.mainContext;
		log.error("loaded");
		return fullcontext;
	}
}
