/**
 * Copyright (C) 2010 [[XYZ]], Helmholtz Centre for Environmental Research GmbH - UFZ <abmland@ufz.de>
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package abmland.models.bindings;

import static abmland.common.Operators.AND;
import static abmland.common.RepastUtils.getMethodsForSchedulingAsActionList;
import static abmland.common.Utils.combine;
import static abmland.common.Utils.evalForeignMethod;
import static abmland.common.Utils.initItems;
import static abmland.models.bindings.Properties.modelsFinishedStatii;
import static java.util.logging.Logger.getLogger;

import java.util.HashMap;
import java.util.Map;
import java.util.logging.Logger;

import repast.simphony.engine.schedule.ScheduledMethod;
import repast.simphony.engine.watcher.Watch;
import repast.simphony.engine.watcher.WatcherTriggerSchedule;
import abmland.common.DataEvent;
import abmland.common.DataListener;

@Deprecated
public class RootAgent implements DataListener {

	private final Logger log = getLogger(getClass().getName());
	private final String namePre = getClass().getSimpleName() + ": ";

	/**
	 * Every time one item in mockFinished changes, this method has to be
	 * triggered.
	 */
	@Watch(//
	watcheeClassName = "abmland.models.bindings.RootAgent", //
	watcheeFieldNames = "mockFinished", //
	whenToTrigger = WatcherTriggerSchedule.LATER)
	public void triggerCompute() {
		log.info(namePre + "triggerCompute");
		// if all models have it's getData finished, set their mayCompute
		// property on true.
		if (combine(AND, mockFinished.values())) {
			Object last = new Object();
			for (Object model : mockFinished.keySet()) {
				evalForeignMethod(model, "mayCompute",
						new Class<?>[] { boolean.class }, true);
				log.info(namePre
						+ model.getClass().getSimpleName() + " mayCompute = "
						+ evalForeignMethod(model, "mayCompute"));
				last = model;
			}
			// Reset the status again for the next cycle of scheduling
			modelsFinishedStatii.put(last, false);
			mockFinished.put(last, false);
		}
	}

	public Map<Object, Boolean> mockFinished = new HashMap<Object, Boolean>();

//	public void setMockFinished(Map<Object, Boolean> isMockFinished) {
//		this.mockFinished = isMockFinished;
//	}

	public Map<Object, Boolean> mockFinished() {
		return this.mockFinished;
	}

	/**
	 * Should be prioritized at begin of the schedule, because it initializes
	 * the watcher. Highest priority.
	 */
	@ScheduledMethod(//
	start = 1, //
	interval = 1, //
	shuffle = false, //
	priority = 900)
	public void mockFinishedStatii() {
		log.info(namePre + "mockFinish");
		this.mockFinished = modelsFinishedStatii;
	}

	/**
	 * If the main context (is a DataListener on each of the models) receives
	 * dataChanged event, it puts this in the map mapping int-values (models'
	 * hash codes) to a binary status (ready or not).
	 */
	/** {@inheritedDoc} */
	public void dataChanged(DataEvent dataEvent) {
		modelsFinishedStatii.put(dataEvent.getSource(), true);
		log.info(namePre + dataEvent.getSource().getClass().getSimpleName()
				+ " has it's getData finished. " + " mayCompute = "
				+ evalForeignMethod(dataEvent.getSource(), "mayCompute"));
	}

//	/**
//	 * Should have the highest priority of all scheduled actions
//	 */
//	@ScheduledMethod(//
//	start = 1, //
//	interval = 1, //
//	shuffle = false, //
//	priority = 1000)
//	public void stupidItemize() {
//		initItems();
//		getMethodsForSchedulingAsActionList(this);
//	}
}
