/**
 * Copyright (C) 2010 [[XYZ]], Helmholtz Centre for Environmental Research GmbH - UFZ <abmland@ufz.de>
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package abmland.models.config;

import static org.apache.log4j.Logger.getLogger;

import java.io.File;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.log4j.Logger;
import org.simpleframework.xml.Element;
import org.simpleframework.xml.ElementList;
import org.simpleframework.xml.core.Commit;

import abmland.data.CLCover;
import abmland.mainctrl.config.CLC;

public class NaiveConfig {
	private final Logger log = getLogger(getClass().getName());

	@ElementList
	private List<CLC> iluTemplates = new ArrayList<CLC>();

	private Map<CLCover, CLC> templateMap = new HashMap<CLCover, CLC>();

	@Commit
	public void setupMap() {
		for (CLC t : iluTemplates)
			templateMap.put(t.id, t);
	}

	public Map<CLCover, CLC> getLuMappings() {
		return templateMap;
	}

	public void addTemplate(CLC iluTemplate) {
		iluTemplates.add(iluTemplate);
	}

	public void setAsciiFile(String filename) {
		this.asciifile = filename;
	}

	public String getAsciiFile() {
		return this.asciifile;
	}

	/**
	 * The name for the ascii file, referred to by that configuration.
	 *
	 * XXX What's the purpose here
	 */
	@Element
	private String asciifile = new String();

	/**
	 * XXX Needed?
	 */
	public void read() {
		try {
			log.debug("");
			new File(getClass().getClassLoader().getResource(asciifile).toURI());
		} catch (URISyntaxException e) {
			log.error("");
			e.printStackTrace();
		}
	}
}
