/**
 * Copyright (C) 2010 [[XYZ]], Helmholtz Centre for Environmental Research GmbH - UFZ <abmland@ufz.de>
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package abmland.models.config;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.EnumMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.Map.Entry;

import org.simpleframework.xml.Attribute;
import org.simpleframework.xml.core.Commit;

import abmland.data.Populationclazzes;

public class PhiPerCohort {

	@Attribute
	public float COHORT00 //
			,
			COHORT01 //
			, COHORT02 //
			, COHORT03 //
			, COHORT04 //
			, COHORT05 //
			, COHORT06 //
			, COHORT07 //
			, COHORT08 //
			, COHORT09 //
			, COHORT10 //
			, COHORT11 //
			, COHORT12 //
			, COHORT13 //
			, COHORT14 //
			, COHORT15 //
			, COHORT16;

	private Map<Populationclazzes, Float> phiPerCohort = new EnumMap<Populationclazzes, Float>(
			Populationclazzes.class);

	public Set<Entry<Populationclazzes, Float>> dumpPhiPerCohort() {
		return phiPerCohort.entrySet();
	}

	@Commit
	public void onCommit() {
		List<Float> cohorts = Arrays.asList(COHORT00,
				COHORT01, COHORT02, COHORT03, COHORT04, COHORT05, COHORT06,
				COHORT07, COHORT08, COHORT09, COHORT10, COHORT11, COHORT12,
				COHORT13, COHORT14, COHORT15, COHORT16);
		short listPos = 0;
		for (Float phi : cohorts) {
			phiPerCohort.put(Populationclazzes.values()[listPos++], phi);
		}
	}
}
