/**
 * Copyright (C) 2010 [[XYZ]], Helmholtz Centre for Environmental Research GmbH - UFZ <abmland@ufz.de>
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package abmland.models.config;

import java.util.EnumMap;
import java.util.Map;
import java.util.Set;
import java.util.Map.Entry;

import org.simpleframework.xml.Attribute;
import org.simpleframework.xml.ElementMap;

import abmland.data.Householdtypes;

public class ResidentConf implements ModelConfig {

	@ElementMap
	public Map<Householdtypes, HouseholdtypeParameters> householdtypes = new EnumMap<Householdtypes, HouseholdtypeParameters>(
			Householdtypes.class);

//	@Override
	public String getModelConfigName() {
		return "ResidentConf";
	}

	public void put(Householdtypes key, HouseholdtypeParameters value) {
		householdtypes.put(key, value);
	}

	public Set<Entry<Householdtypes, HouseholdtypeParameters>> dumpEntries() {
		return householdtypes.entrySet();
	}

	@Attribute
	private String modelClassName;

	public String getModelClassName() {
		return modelClassName;
	}

	@Attribute
	private String agentClassName;

	public String getAgentClassName() {
		return agentClassName;
	}
}
