/**
 * Copyright (C) 2010 [[XYZ]], Helmholtz Centre for Environmental Research GmbH - UFZ <abmland@ufz.de>
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package abmland.models.serve;

import java.util.Map;
import java.util.Set;

import repast.simphony.space.grid.GridPoint;
import abmland.data.CLCover;
import abmland.models.IPlannerModel;
import abmland.types.ICLCoversAllCells;
import abmland.types.IPressure;

public class PlannerModelServer2 implements IPlannerModel {

	private IPlannerModel model;

	public PlannerModelServer2(IPlannerModel model) {
		this.model = model;
	}

	/** {@inheritDoc} */ public Map<Map<GridPoint, CLCover>, Boolean> getPermissionForProposals() {
		return model.getPermissionForProposals();
	}

	/** {@inheritDoc} */ public Map<GridPoint, Map<CLCover, IPressure>> getSpatialPressure() {
		return model.getSpatialPressure();
	}

	/** {@inheritDoc} */ public Map<CLCover, IPressure> getGlobalPressure() {
		return model.getGlobalPressure();
	}

	/** {@inheritDoc} */ public Set<Map<GridPoint,CLCover>> getPendingProposals() {
		return model.getPendingProposals();
	}

	/** {@inheritDoc} */ public ICLCoversAllCells getPermittedLandUse() {
		return model.getPermittedLandUse();
	}
}
