/**
 * Copyright (C) 2010 [[XYZ]], Helmholtz Centre for Environmental Research GmbH - UFZ <abmland@ufz.de>
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package abmland.models.serve;

import java.util.Map;

import repast.simphony.space.grid.GridPoint;
import abmland.data.Householdtypes;
import abmland.data.Issuetypes;
import abmland.models.IResidentModel;
import abmland.types.IHouseholdNumber;
import abmland.types.ISatisfaction;

public class ResidentModelServer2 implements IResidentModel {

	private IResidentModel model;

	public ResidentModelServer2(IResidentModel model) {
		this.model = model;
	}

	/** {@inheritDoc} */ public Map<GridPoint, Map<Householdtypes, Map<Issuetypes, ISatisfaction>>> getSatisfaction() {
		return model.getSatisfaction();
	}

	/** {@inheritDoc} */ public Map<GridPoint, Map<Householdtypes, IHouseholdNumber>> getTotalHouseholdNumber() {
		return model.getTotalHouseholdNumber();
	}
}
