/**
 * Copyright (C) 2010 [[XYZ]], Helmholtz Centre for Environmental Research GmbH - UFZ <abmland@ufz.de>
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package abmland.types;


/**
 * {@code Percentage} has some constraints for it's values' ranges...
 *
 * Values must be in the range from 0.0f to 1.0f, else a special value will be returned.
 */
@BoundedFloat(MIN = 0.0f, MAX = 1.0f)
public interface Share {

//	static final float MIN = 0.0f;
//
//	static final float MAX = 1.0f;

	Float MIN();

	Float MAX();
}
