/**
 * Copyright (C) 2010 [[XYZ]], Helmholtz Centre for Environmental Research GmbH - UFZ <abmland@ufz.de>
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package abmland.types.impl;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

public abstract class AbstractMapAdapter<K,V> implements Map<K, V> {

	private Map<K, V> map;

	private Map<K, V> getMap() {
		return this.map;
	}

	public AbstractMapAdapter(Map<K, V> map) {
		// TODO Auto-generated constructor stub
		this.map = map;
	}

	public AbstractMapAdapter() {
		this.map = new HashMap<K, V>();
	}

	/** {@inheritDoc} */
	public void clear() {
		getMap().clear();
	}

	/** {@inheritDoc} */
	public boolean containsKey(Object key) {
		return getMap().containsKey(key);
	}

	/** {@inheritDoc} */
	public boolean containsValue(Object value) {
		return getMap().containsValue(value);
	}

	/** {@inheritDoc} */
	public Set<java.util.Map.Entry<K, V>> entrySet() {
		return getMap().entrySet();
	}

	/** {@inheritDoc} */
	public V get(Object key) {
		return getMap().get(key);
	}

	/** {@inheritDoc} */
	public boolean isEmpty() {
		return getMap().isEmpty();
	}

	/** {@inheritDoc} */
	public Set<K> keySet() {
		return getMap().keySet();
	}

	/** {@inheritDoc} */
	public V put(K key, V value) {
		return getMap().put(key, value);
	}

	/** {@inheritDoc} */
	public void putAll(Map<? extends K, ? extends V> m) {
		getMap().putAll(m);
	}

	/** {@inheritDoc} */
	public V remove(Object key) {
		return getMap().remove(key);
	}

	/** {@inheritDoc} */
	public int size() {
		return getMap().size();
	}

	/** {@inheritDoc} */
	public Collection<V> values() {
		return getMap().values();
	}

}
