/**
 * Copyright (C) 2010 [[XYZ]], Helmholtz Centre for Environmental Research GmbH - UFZ <abmland@ufz.de>
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package abmland.types.impl;

import java.util.HashMap;
import java.util.Map;

import repast.simphony.space.grid.GridPoint;
import abmland.data.CLCover;
import abmland.types.ICLCoverSomeCells;

//FIXME (p:'Paper')
public class CLCoverSomeCells extends AbstractMapAdapter<GridPoint, CLCover>
		implements ICLCoverSomeCells {

	public CLCoverSomeCells(Map<GridPoint, CLCover> map) {
		super(map);
	}

	// Wouldn't it be better here to have CLCoverSomeCells(CLCover clCover,
	// GridPoint... points) as signature, because 1) some cells aren't an closed
	// area in all cases and 2) some cells aren't all cells
	public CLCoverSomeCells(CLCover clCover, int... dimensions) {

		super(new HashMap<GridPoint, CLCover>());

		int[] dimX = (dimensions.length < 1) ? new int[0] : dimensions;

		for (int dimX_y = 0; dimX_y < dimX[1]; dimX_y++) {
			for (int dimX_x = 0; dimX_x < dimX[0]; dimX_x++) {
				// locationStorage.put(new GridPoint(dimX_x, dimX_y),
				// clCovers.length > 0 ? clCovers[0] : new Integer(2));
				super.put(new GridPoint(dimX_x, dimX_y), clCover);
			}
		}
	}

	// FIXME-SOL
	public CLCoverSomeCells(CLCover clCover, GridPoint... points) {

		super(new HashMap<GridPoint, CLCover>());

		for (GridPoint gridPoint : points) {
			super.put(gridPoint, clCover);
		}
	}

}
